component: VelodyneDriverFaults
proto_imports:
  - vehicle/sensors/lidar/velodyne/driver/diagnostics/driver_diagnostics.proto
metric: VelodyneControllerMetric
namespace: zoox::lidar::velodyne
# Note: ID 1-4 changed to WARNING as per SWAT-3085
# TODO: Change back to ERROR for SWAT-3087 AFTER SWAT-3086 complete
faults:
  - id: 1
    name: LidarLaserOff
    severity: ERROR
    description: "Lidar laser state is OFF"
    freeze_frame: StatusFreezeFrame
    triggers_nogo: true
  - id: 2
    name: LidarMotorOff
    severity: ERROR
    description: "Lidar motor state is OFF"
    freeze_frame: StatusFreezeFrame
    triggers_nogo: true
  - id: 3
    name: LidarPhaselockOff
    severity: WARNING
    description: "Lidar phase lock is OFF"
    freeze_frame: StatusFreezeFrame
  - id: 4
    name: LidarGpsNotLocked
    severity: WARNING
    description: "Lidar GPS is not locked"
    freeze_frame: StatusFreezeFrame
  - id: 5
    name: LidarVersionMismatch
    severity: ERROR
    description: "Lidar firmware versions are incorrect"
    freeze_frame: VersionMismatchFreezeFrame
    triggers_nogo: true
  - id: 6
    name: LidarSerialNumberMismatch
    severity: ERROR
    description: "Lidar serial number does not match configured serial number"
    freeze_frame: SerialNumberMismatchFreezeFrame
    triggers_nogo: true
  - id: 7
    name: ControllerQueryFault
    severity: ERROR
    description: "Error seen when querying the lidar for status"
    deprecated: true
  - id: 8
    name: NetworkSettingsMismatch
    severity: ERROR
    description: "Lidar network settings do not match expected values"
    freeze_frame: VelodyneNetworkSettingsFreezeFrame
    triggers_nogo: true
  - id: 9
    name: LidarSettingsMismatch
    severity: ERROR
    description: "Lidar settings do not match expected values"
    freeze_frame: SettingsFreezeFrame
    triggers_nogo: true
  - id: 10
    name: LidarSpinDirectionIncorrect
    severity: ERROR
    description: "Lidar spin direction is incorrect"
    freeze_frame: StatusFreezeFrame
    triggers_nogo: true
  - id: 11
    name: LidarSpinRateIncorrect
    severity: ERROR
    description: "Lidar spin rate is incorrect"
    freeze_frame: StatusFreezeFrame
    triggers_nogo: true
  - id: 12
    name: NoWebServerConnection
    severity: WARNING
    description: "Unable to reach lidar web server"
  - id: 13
    name: QueryResponseParseError
    severity: WARNING
    description: "Failed to parse response from lidar web server"
  - id: 14
    name: TemperatureOutOfRange
    severity: WARNING
    description: "Lidar temperature out of valid operating range"
    freeze_frame: VelodyneDiagnosticsFreezeFrame
    triggers_nogo: false
  - id: 15
    name: VoltageOutOfRange
    severity: WARNING
    description: "Lidar internal voltage out of valid operating range"
    freeze_frame: VelodyneDiagnosticsFreezeFrame
    triggers_nogo: false
  - id: 16
    name: CurrentOutOfRange
    severity: WARNING
    description: "Lidar current usage out of valid operating range"
    freeze_frame: VelodyneDiagnosticsFreezeFrame
    triggers_nogo: false
